program Test;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, Fixpunkt, windows
  { you can add units after this };   

type
  { TBase10Neg4 }

  // 10^-4
  TBase10Neg4 = class
    class function Base: Integer; inline;
    class function Exp: Integer; inline;
    class function Multiply(const AValue: Int64): Int64; overload; Inline;
    class function Multiply(const AValue: Double): Double; overload; Inline;
    class function Divide(const AValue: Int64): Int64; overload; Inline;
    class function Divide(const AValue: Double): Double; overload; Inline;
  end;

  T4DigitDecimal = specialize TFixpointNumber<TBase10Neg4>;

{ TBase10Neg4 }

class function TBase10Neg4.Base: Integer;
begin
  Result := 10;
end;

class function TBase10Neg4.Exp: Integer;
begin
  Result := -4;
end;

class function TBase10Neg4.Multiply(const AValue: Int64): Int64;
begin
  Result := AValue div 10000;
end;

class function TBase10Neg4.Multiply(const AValue: Double): Double;
begin
  Result := AValue / 10000;
end;

class function TBase10Neg4.Divide(const AValue: Int64): Int64;
begin
  Result := AValue * 10000;
end;

class function TBase10Neg4.Divide(const AValue: Double): Double;
begin
  Result := AValue * 10000;
end;
var
  f, fone: T4DigitDecimal;
  c, cone: Currency;
  Start: DWORD;
  numberSequence: array[0..9999] of Integer;
  CurrSequence: array[0..9999] of Currency;
  FixSequence: array[0..9999] of T4DigitDecimal;
  j, i: Integer;
begin
  for i:=0 to 9999 do
    numberSequence[i] := Random(10000) + 1000;

  start := GetTickCount;
  for i:=0 to 10000 do
    for j:= 0 to 9999 do
      CurrSequence[j] := Currency(numberSequence[j]);
  WriteLn('Currency From Integer: ', GetTickCount-Start, ' ms');
  start := GetTickCount;
  for i:=0 to 10000 do
    for j:= 0 to 9999 do
      FixSequence[j] := T4DigitDecimal(numberSequence[j]);
  WriteLn('Fixpoint From Integer: ', GetTickCount-Start, ' ms');        
  start := GetTickCount;
  for i:=0 to 10000 do
    for j:= 0 to 9999 do
      CurrSequence[j] := Currency(numberSequence[j] / 1000);
  WriteLn('Currency From Double: ', GetTickCount-Start, ' ms');
  start := GetTickCount;
  for i:=0 to 10000 do
    for j:= 0 to 9999 do
      FixSequence[j] := T4DigitDecimal(numberSequence[j] / 1000);
  WriteLn('Fixpoint From Double: ', GetTickCount-Start, ' ms');

  start := GetTickCount;
  c:=0;
  for i:=0 to 10000 do
    for j:= 0 to 9999 do
      c := c + CurrSequence[j];
  WriteLn('Currency Add: ', GetTickCount-Start, ' ms');
  WriteLn('Result: ', c);
  start := GetTickCount;
  f:=0;
  for i:=0 to 10000 do
    for j:= 0 to 9999 do
      f := f + FixSequence[j];
  WriteLn('Fixpoint Add: ', GetTickCount-Start, ' ms');
  WriteLn('Result: ', f.ToString);   

  start := GetTickCount; 
  cone:=1;
  for i:=0 to 10000 do
    for j:= 0 to 9999 do
    begin
      if j mod 10 = 0 then
        c := cone;
      c := c * CurrSequence[j];
    end;
  WriteLn('Currency Mul: ', GetTickCount-Start, ' ms');
  WriteLn('Result: ', c);
  start := GetTickCount;
  fone:=1;
  for i:=0 to 10000 do
    for j:= 0 to 9999 do   
    begin
      if j mod 10 = 0 then
        f := fone;
      f := f * FixSequence[j];
    end;
  WriteLn('Fixpoint Mul: ', GetTickCount-Start, ' ms');
  WriteLn('Result: ', f.ToString);
end.

